# -*- encoding: utf-8 -*-
require "rspec"
require "capybara"
require 'capybara/rspec'
include Capybara::DSL
require "capybara-webkit"
require 'headless'
require 'ruby-debug'

headless = Headless.new(:display => 99, :reuse => true, :destroy_at_exit => false)
headless.start
Capybara.default_wait_time = 5

Capybara.register_driver :selenium_chrome do |app|
  Capybara::Selenium::Driver.new(app, :browser => :chrome)
end

WEBKIT_UA = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_6_8) AppleWebKit/535.8 (KHTML, like Gecko) Chrome/17.0.942.0 Safari/535.8'

shared_examples_for "google.com" do

  it "should search for browser", :js => true do
    visit "http://www.google.com/"
    page.should have_no_css('#cnt')
    fill_in "q", :with => "browser"
    page.should have_css('#cnt')
    find('button[name="btnG"]').click
    page.should have_content('browserに関連する検索キーワード')
  end

  #it "should count down", :js => true do
  #  visit "http://localhost/test.html"
  #  click_button 'count down'
  #  wait_until(15) do
  #    page.evaluate_script('counts') == 0
  #  end
  #  page.should have_content('fin')
  #end

end
