(function() {
  var env = (function() {
    if (typeof WScript === 'object') {
      return 'jscript';
    } else if (typeof pc2line === 'function') {
      return 'spidermonkey';
    } else if (typeof checkSyntax === 'function') {
      return 'jsc';
    } else if (typeof process === 'object') {
      return 'node';
    } else if (typeof read === 'function') {
      return 'v8';
    }
  })();

  function failed(a) {
    if (env === 'jscript') {
      WScript.StdErr.WriteLine(a);
      WScript.Quit(1);
    } else if (env === 'jsc' || env === 'v8') {
      puts(a);
      throw new Error(a);
    } else {
      throw new Error(a);
    }
  }

  function puts(a) {
    if (typeof console !== 'undefined') {
      console.log(a);
    } else if (typeof print === 'function') {
      print(a);
    } else if (this.WScript) {
      WScript.Echo(String(a));
    }
  }

  function d(a) {
    if (Object.getOwnPropertyNames) {
      puts(Object.getOwnPropertyNames(a));
    } else {
      var r = [];
      for (var i in a) {
        try {
          r.push(i + ': ' + a[i]);
        } catch (e) {
          r.push(i + ': ' + e);
        }
      }
      puts(r.join(', '));
    }
  }

  function assertEquals(a, b) {
    if (a === b) {
      puts('OK');
    } else {
      failed('test failed. "' + a + '" is not equal "' + b + '"');
    }
  }

  function _load(file, callback) {
    if (typeof require === 'function') {
      var fs = require('fs');
      fs.readFile(file, 'utf-8', function(err, txt) {
        var tests = eval(txt);
        callback && callback(tests);
      });
    } else if (typeof load === 'function') {
      load(file);
      callback && callback(tests);
    }
  }
  /*
  var base = '/Users/shogo/Dropbox/text/js4/';
  _load(base + 'test_list.js', function(tests){
    for (var i = 0; i < tests.length; i++) {
      _load(base + tests[i]);
    }
    if (typeof process === 'object') process.exit();
  });
  */
})();
